/*

Copyright (c) 2010, Embedded Adventures, www.embeddedadventures.com
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice,
  this list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

- Neither the name of Embedded Adventures nor the names of its contributors
  may be used to endorse or promote products derived from this software
  without specific prior written permission.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
THE POSSIBILITY OF SUCH DAMAGE.

Contact us at admin@embeddedadventures.com

*/

/*! \file config_bits.h
    \brief Trying the impossible task of creating some commonality around the config settings
	
*/


#include "config.h"

#ifdef _PIC16
#ifdef _PIC16F88
	#pragma DATA _CONFIG, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _PWRTE_OFF & _WDT_OFF & _PWRTE_ON & _BODEN_OFF &_MCLR_ON & _INTRC_IO  
#endif

#ifdef _PIC16F876A
	#pragma DATA _CONFIG, _CP_OFF & _DEBUG_OFF & _WRT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _PWRTE_ON & _WDT_OFF & _HS_OSC
#endif

#endif

#ifdef _PIC18

#if defined(_PIC18F252)|| defined(_PIC18F452)
	#pragma DATA    _CONFIG1H,  _OSCS_OFF_1H & _HS_OSC_1H 
	#pragma DATA    _CONFIG2L, _BOR_OFF_2L & _BORV_20_2L & _PWRT_ON_2L
	#pragma DATA    _CONFIG2H, _WDT_OFF_2H & _WDTPS_128_2H
	#pragma DATA    _CONFIG3H, _CCP2MX_ON_3H
	#pragma DATA    _CONFIG4L, _STVR_ON_4L & _LVP_OFF_4L & _DEBUG_OFF_4L
	#pragma DATA    _CONFIG5L, _CP0_OFF_5L & _CP1_OFF_5L & _CP2_OFF_5L & _CP3_OFF_5L
	#pragma DATA    _CONFIG5H, _CPB_OFF_5H & _CPD_OFF_5H
	#pragma DATA    _CONFIG6L, _WRT0_OFF_6L & _WRT1_OFF_6L & _WRT2_OFF_6L & _WRT3_OFF_6L
	#pragma DATA    _CONFIG6H, _WRTC_OFF_6H & _WRTB_OFF_6H & _WRTD_OFF_6H
	#pragma DATA    _CONFIG7L, _EBTR0_OFF_7L & _EBTR1_OFF_7L & _EBTR2_OFF_7L & _EBTR3_OFF_7L
	#pragma DATA    _CONFIG7H, _EBTRB_OFF_7H
 #else
   #if defined(_PIC18F4550) 
 
	#pragma DATA	_CONFIG1L, _PLLDIV_5_1L & _CPUDIV_OSC4_PLL6_1L & _USBDIV_2_1L
	#pragma DATA    _CONFIG1H, _FOSC_HSPLL_HS_1H & _FCMEN_OFF_1H & _IESO_OFF_1H
	#pragma DATA    _CONFIG2L, _PWRT_ON_2L & _BOR_OFF_2L  & _VREGEN_OFF_2L
	#pragma DATA    _CONFIG2H, _WDT_OFF_2H & _WDTPS_128_2H
	#pragma DATA    _CONFIG3H, _CCP2MX_OFF_3H & _LPT1OSC_OFF_3H & _PBADEN_OFF_3H & _MCLRE_ON_3H
	#pragma DATA    _CONFIG4L, _STVREN_ON_4L & _LVP_OFF_4L & _DEBUG_OFF_4L & _XINST_OFF_4L
	#pragma DATA    _CONFIG5L, _CP0_OFF_5L & _CP1_OFF_5L & _CP2_OFF_5L & _CP3_OFF_5L
	#pragma DATA    _CONFIG5H, _CPB_OFF_5H & _CPD_OFF_5H
	#pragma DATA    _CONFIG6L, _WRT0_OFF_6L & _WRT1_OFF_6L & _WRT2_OFF_6L & _WRT3_OFF_6L
	#pragma DATA    _CONFIG6H, _WRTC_OFF_6H & _WRTB_OFF_6H & _WRTD_OFF_6H
	#pragma DATA    _CONFIG7L, _EBTR0_OFF_7L & _EBTR1_OFF_7L & _EBTR2_OFF_7L & _EBTR3_OFF_7L
	#pragma DATA    _CONFIG7H, _EBTRB_OFF_7H

   #else
   
   #if defined(_PIC18F67J50) 
	#pragma DATA	_CONFIG1L, _DEBUG_OFF_1L & _XINST_OFF_1L & _STVREN_OFF_1L & _PLLDIV_5_1L & _WDT_OFF_1L
	#pragma DATA    _CONFIG1H, _CP0_OFF_1H & _CPUDIV_OSC1__1H
	
	#pragma DATA    _CONFIG2L, _IESO_OFF_2L & _FCMEN_OFF_2L & _FOSC_HSPLL_2L
	#pragma DATA    _CONFIG2H, _WDTPS_32768_2H
	#pragma DATA    _CONFIG3L, _WAIT_OFF_3L & _BW_8_3L & _MODE_MM_3L & _EASHFT_OFF_3L
	#pragma DATA    _CONFIG3H, _MSSP_MSK7_3H & _PPMX_DEFAULT_3H & _ECCPMX_DEFAULT_3H & _CCP2MX_DEFAULT_3H
  

   #else
   
	 //#pragma DATA    _CONFIG1H, _OSC_HS_1H //_OSC_HSPLL_1H //
	   #pragma DATA    _CONFIG1H, _OSC_HS_1H & _IESO_OFF_1H
	   #pragma DATA    _CONFIG2L, _BOREN_SBORDIS_2L & _BORV_2_2L & _PWRT_ON_2L
	   #pragma DATA    _CONFIG2H, _WDT_OFF_2H & _WDTPS_128_2H
	   #pragma DATA    _CONFIG3H, _CCP2MX_PORTC_3H & _PBADEN_OFF_3H & _MCLRE_ON_3H
	   #pragma DATA    _CONFIG4L, _STVREN_ON_4L & _LVP_OFF_4L & _DEBUG_OFF_4L & _XINST_OFF_4L
	   #pragma DATA    _CONFIG5L, _CP0_OFF_5L & _CP1_OFF_5L & _CP2_OFF_5L & _CP3_OFF_5L
	   #pragma DATA    _CONFIG5H, _CPB_OFF_5H & _CPD_OFF_5H
	   #pragma DATA    _CONFIG6L, _WRT0_OFF_6L & _WRT1_OFF_6L & _WRT2_OFF_6L & _WRT3_OFF_6L
	   #pragma DATA    _CONFIG6H, _WRTC_OFF_6H & _WRTB_OFF_6H & _WRTD_OFF_6H
	   #pragma DATA    _CONFIG7L, _EBTR0_OFF_7L & _EBTR1_OFF_7L & _EBTR2_OFF_7L & _EBTR3_OFF_7L
	   #pragma DATA    _CONFIG7H, _EBTRB_OFF_7H
	#endif
 #endif
#endif
#endif
