#include "ccld.h"
#include "config.h"
#include "pic_serial.h"
 
#define MAX_CURSOR DSP_0801_TOTAL_CHARS 


uns8 cursor = 0;
uns8 max_cursor = MAX_CURSOR;

uns16 data_array[MAX_CURSOR];

void ea_dsp0801_fill() {
	data_array[0] = 0x0102;
	data_array[1] = 0x0304;
	data_array[2] = 0x0506;
	data_array[3] = 0x0708;
	data_array[4] = 0x0910;
	data_array[5] = 0x1112;
	data_array[6] = 0x1314;
	data_array[7] = 0x1516;
}	

						
void ea_dsp0801_set_cursor(uns8 x) {
	cursor = x;
}

uns16 ea_dsp0801_translate(uns8 my_char) {
	uns16 result = 0;
	

	switch (my_char) {

		case ' ': result = 0b0000000000000000; break;
		case '0': result = 0b0010010000111111; break;
		case '1': result = 0b0000000000000110; break;
		case '2': result = 0b0000000011011011; break;
		case '3': result = 0b0000000010001111; break;
		case '4': result = 0b0001001011100000; break;
		case '5': result = 0b0000000011101101; break;
		case '6': result = 0b0000000011111101; break;
		case '7': result = 0b0000000000000111; break;
		case '8': result = 0b0000000011111111; break;
		case '9': result = 0b0000000011101111; break;
		case 'A': result = 0b0000000011110111; break;
		case 'B': result = 0b0001001010001111; break;
		case 'C': result = 0b0000000000111001; break;
		case 'D': result = 0b0001001000001111; break;
		case 'E': result = 0b0000000001111001; break;
		case 'F': result = 0b0000000001110001; break;
		case 'G': result = 0b0000000010111101; break;
		case 'H': result = 0b0000000011110110; break;
		case 'I': result = 0b0001001000001001; break;
		case 'J': result = 0b0000000000011110; break;
		case 'K': result = 0b0000110001110000; break;
		case 'L': result = 0b0000000000111000; break;
		case 'M': result = 0b0000010100110110; break;
		case 'N': result = 0b0000100100110110; break;
		case 'O': result = 0b0000000000111111; break;
		case 'P': result = 0b0000000011110011; break;
		case 'Q': result = 0b0000100000111111; break;
		case 'R': result = 0b0000100011110011; break;
		case 'S': result = 0b0000000011101101; break;
		case 'T': result = 0b0001001000000001; break;
		case 'U': result = 0b0000000000111110; break;
		case 'V': result = 0b0010010000110000; break;
		case 'W': result = 0b0010100000110110; break;
		case 'X': result = 0b0010110100000000; break;
		case 'Y': result = 0b0001010100000000; break;
		case 'Z': result = 0b0010010000001001; break;
		case '*': result = 0b0011111111000000; break;

	}
	return result;
}		

	
void ea_dsp0801_print_str(char *str) {
uns8 temp_bit;
	while ((*str != 0) && (cursor < max_cursor)) {
		temp_bit = test_bit(data_array[cursor], 14);
		
		data_array[cursor] = ea_dsp0801_translate(*str);
		if (temp_bit) {	// preserve dot LED
			set_bit(data_array[cursor], 14);
		}
		cursor++;	
		str++;
	}
}

void ea_dsp0801_display(void) {

uns8 count;

	for (count = 0; count < DSP_0801_TOTAL_CHARS ; count ++) {
		ccld_write_data(data_array[count]);
	}
	ccld_latch_data();
}
	


void ea_dsp0801_set_raw(uns8 pos, uns16 raw) {
	data_array[pos] = raw;
}	




void ea_dsp0401b_setup_io(void) {
	ccld_setup_io();
}	
	
void ea_dsp0801_set_dot(uns8 pos) {
	set_bit(data_array[pos] ,14);
}	

void ea_dsp0801_clear_dot(uns8 pos) {
	clear_bit(data_array[pos], 14);
}
