/*

Copyright (c) 2010, Embedded Adventures, www.embeddedadventures.com
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice,
  this list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

- Neither the name of Embedded Adventures nor the names of its contributors
  may be used to endorse or promote products derived from this software
  without specific prior written permission.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
THE POSSIBILITY OF SUCH DAMAGE.

Contact us at admin@embeddedadventures.com

*/

#include "hc4led.h"
#include "pic_serial.h"

void hc4led_setup() {
	spi_setup();
}
	
uns8 hc4led_convert(uns8 digit) {
	switch (digit) {
	case ' ': return 0;
	case '0': return 126;
	case '1': return 24;
	case '2': return 109;
	case '3': return 61;
	case '4': return 27;
	case '5': return 55;
	case '6': return 115;
	case '7': return 28;
	case '8': return 127;
	case '9': return 31+32;
	case '\'': return 15;
	}	
}
	
void hc4led_write_str(char *data) {

uns8 count, digit;
char converted[5];

	count = 4;
	do {
		digit = data[count-1];
		converted[count-1] = hc4led_convert(digit);
		count--;
	   } while (count > 0);
	count = 4;
	do {
		digit = converted[count-1];
		spi_write(digit);
		count--;
	   } while (count > 0);
	   
}

