/*

Copyright (c) 2010, Embedded Adventures, www.embeddedadventures.com
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice,
  this list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

- Neither the name of Embedded Adventures nor the names of its contributors
  may be used to endorse or promote products derived from this software
  without specific prior written permission.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
THE POSSIBILITY OF SUCH DAMAGE.

Contact us at admin@embeddedadventures.com

*/

/*! \file its_mode1.h
    \brief ITS networking mode 1
	
*/
#ifndef its_mode1_h
#define its_mode1_h

#include "pic_utils.h"

/* Put this in your config.h

// - - - - - - - - - - - - - - - - - - - - 
// ITS mode1 defines
// - - - - - - - - - - - - - - - - - - - - 

#define ITS_EA { 0, 0, 0, 0, 0, 0, 0, 1 } 
#define ITS_MODE1_CONTROLLER
//#define ITS_MODE1_DEVICE

*/


enum _its1_result { RESULT_SUCCESSFUL, RESULT_FAILED };
typedef enum _its1_result its1_result;

enum _its1_state { STATE_STARTUP, STATE_RUNNING, STATE_SEARCHING, STATE_ASSOCIATED,
	               STATE_UNASSOCIATED };
typedef enum _its1_state its1_state;

extern its1_state state;

/* routines for both controller and device */

void its1_setup_io();


/* controller routines */

uns8 its1_controller_init(uns16 my_device_id, uns16 network_id);
void its1_controller_receive_callback(uns16 device_id, uns8 *data, uns8 data_length);
its1_result its1_controller_transmit(uns16 device_id, uns8 *data, uns8 data_length);
void its1_controller_process();

/* internal */
its1_result its1_controller_handle_association(uns16 pan_id, uns16 its_device_id);
/* Device specific routines */

its1_result its1_device_init(uns16 my_device_id, uns16 network_id);
its1_result its1_find_controller();
void its1_device_receive_callback(uns8 *data, uns8 data_length);
its1_result its1_device_transmit(uns8 *data, uns8 data_length);
void its1_device_process();

#endif