/*

Copyright (c) 2010, Embedded Adventures, www.embeddedadventures.com
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice,
  this list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

- Neither the name of Embedded Adventures nor the names of its contributors
  may be used to endorse or promote products derived from this software
  without specific prior written permission.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
THE POSSIBILITY OF SUCH DAMAGE.

Contact us at admin@embeddedadventures.com

*/

/*! \file ms5540.h
    \brief MS5540 temperature and pressure sensor routines

	A library to communicate with the ms5540 sensor
*/
/*



Put the following into your config.h

// - - - - - - - - - - - - - - - - - - - - 
// ms5540 defines
// - - - - - - - - - - - - - - - - - - - - 


#define ms5540_sclk_port PORTB
#define ms5540_sclk_pin  4

#define ms5540_din_port PORTB
#define ms5540_din_pin  2

#define ms5540_dout_port PORTB
#define ms5540_dout_pin  1

  
*/

#include "pic_utils.h"



/**
	\brief Setup ms5540 ports and pins
	
*/
#define ms5540_setup() ms5540_setup_io()
void ms5540_setup_io(void);
void ms5540_init();


uns16 ms5540_get_config(uns8 config_word);
void ms5540_reset();
uns16 ms5540_get_raw_pressure();
uns16 ms5540_get_raw_temp();
void ms5540_calc_temp_and_pressure();