/*

Copyright (c) 2010, Embedded Adventures, www.embeddedadventures.com
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice,
  this list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

- Neither the name of Embedded Adventures nor the names of its contributors
  may be used to endorse or promote products derived from this software
  without specific prior written permission.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
THE POSSIBILITY OF SUCH DAMAGE.

Contact us at admin@embeddedadventures.com

*/

/*! \file pic_flash.h
    \brief Flash write / erase routines
	
*/

#ifndef __pic_flash_h
#define __pic_flash_h

#include "pic_utils.h"
#include "config.h"

/* Place this in your config.h

// - - - - - - - - - - - - - - - - - - - - 
// pic_flash defines
// - - - - - - - - - - - - - - - - - - - - 

#define FLASH_MAX_WRITE_CHUNK 16
#define FLASH_MEM_ADDR_TYPE uns16

*/


void flash_erase(FLASH_MEM_ADDR_TYPE address);
void flash_write(FLASH_MEM_ADDR_TYPE address, uns8 count, uns8 *data);

#ifndef FLASH_MAX_WRITE_CHUNK
	#error "pic_flash: FLASH_MAX_WRITE_CHUNK not defined in config.h"
#endif	
#ifndef FLASH_MEM_ADDR_TYPE
	#error "pic_flash: FLASH_MEM_ADDR_TYPE not defined in config.h"
#endif	


#endif