/*

Copyright (c) 2010, Embedded Adventures, www.embeddedadventures.com
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice,
  this list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

- Neither the name of Embedded Adventures nor the names of its contributors
  may be used to endorse or promote products derived from this software
  without specific prior written permission.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
THE POSSIBILITY OF SUCH DAMAGE.

Contact us at admin@embeddedadventures.com

*/



#include "pic_pwm.h"
#include "config.h"

uns8 pwm_count;
uns8 pwm_level[PWM_NUM_PINS];


void pwm_set_level(uns8 pwm_item, uns8 level) {
	
	pwm_level[pwm_item] = level;
}

uns8 pwm_get_level(uns8 pwm_item) {
	return pwm_level[pwm_item];
}	

void pwm_set_transition(uns8 pwm_item, uns8 to_level, uns16 steps) {
}	


void pwm_setup_io() {

	make_output(PWM_PORT_0, PWM_PIN_0);
	#if PWM_NUM_PINS > 1
		make_output(PWM_PORT_1, PWM_PIN_1);
	#endif
	#if PWM_NUM_PINS > 2
		make_output(PWM_PORT_2, PWM_PIN_2);
	#endif

}	

void pwm_handle() {
	uns8 count;
	
	pwm_count++;
	
	if (pwm_count == 0) {	// Turn them all on
		set_pin(PWM_PORT_0, PWM_PIN_0);
		#if PWM_NUM_PINS > 1
			set_pin(PWM_PORT_1, PWM_PIN_1);
		#endif
		#if PWM_NUM_PINS > 2
			set_pin(PWM_PORT_2, PWM_PIN_2);
		#endif
	}
	if (pwm_level[0] == pwm_count) {
		clear_pin(PWM_PORT_0, PWM_PIN_0);
	}	
	#if PWM_NUM_PINS > 1
		if (pwm_level[1] == pwm_count) {
			clear_pin(PWM_PORT_1, PWM_PIN_1);
		}
	#endif		
	#if PWM_NUM_PINS > 2
		if (pwm_level[2] == pwm_count) {
			clear_pin(PWM_PORT_2, PWM_PIN_2);
		}
	#endif		
}
