/*

Copyright (c) 2010, Embedded Adventures, www.embeddedadventures.com
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice,
  this list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

- Neither the name of Embedded Adventures nor the names of its contributors
  may be used to endorse or promote products derived from this software
  without specific prior written permission.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
THE POSSIBILITY OF SUCH DAMAGE.

Contact us at admin@embeddedadventures.com

*/




#include "spi.h"

void spi_write(uns8 data) {

uns8 count;
	for (count = 0; count < 8; count++) {
		clear_pin(spi_clk_port, spi_clk_pin);	// set to low
		change_pin(spi_data_port, spi_data_pin, data.7);
		data = data << 1;
		set_pin(spi_clk_port, spi_clk_pin);	// set to low
	}	
		
}



void spi_write_lsb(uns8 data) {

uns8 count;


	for (count = 0; count < 8; count++) {
		clear_pin(spi_clk_port, spi_clk_pin);	// set to low
		change_pin(spi_data_port, spi_data_pin, data.0);
		data = data >> 1;
		set_pin(spi_clk_port, spi_clk_pin);	// set to low
	}	
		
}
	
void spi_setup() {
	clear_bit(tris_array[spi_clk_port - PORTA], spi_clk_pin);   // output
	clear_bit(tris_array[spi_data_port - PORTA], spi_data_pin);   // output

}	

void spi_write_sure(uns8 data) {

uns8 count;
uns8 data_in;

	data_in = data;
	for (count = 0; count < 8; count++) {
		change_pin(spi_data_port, spi_data_pin, data_in.0);
		clear_pin(spi_clk_port, spi_clk_pin);	
		set_pin(spi_clk_port, spi_clk_pin);	
		data_in = data_in >> 1;
	}	
}


void spi_pulse_0() {
		change_pin(spi_data_port, spi_data_pin, 0);
		clear_pin(spi_clk_port, spi_clk_pin);	
		set_pin(spi_clk_port, spi_clk_pin);	
}

void spi_pulse_1() {
		change_pin(spi_data_port, spi_data_pin, 1);
		clear_pin(spi_clk_port, spi_clk_pin);	
		set_pin(spi_clk_port, spi_clk_pin);	/
}