/*

Copyright (c) 2010, Embedded Adventures, www.embeddedadventures.com
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice,
  this list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

- Neither the name of Embedded Adventures nor the names of its contributors
  may be used to endorse or promote products derived from this software
  without specific prior written permission.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
THE POSSIBILITY OF SUCH DAMAGE.

Contact us at admin@embeddedadventures.com

*/

/** \file sure_7seg.c
 	\brief Routines to talk to Sure electronics seven segment displays
*/


#include "sure_7seg.h"

void sure_7seg_setup() {
	spi_setup();
}

	
uns8 sure_7seg_convert(uns8 digit) {
	switch (digit) {
	case ' ': return 0;
	case '0': return 0xfc;
	case '1': return 0x60;
	case '2': return 0xda;
	case '3': return 0xf2;
	case '4': return 0x66;
	case '5': return 0xb6;
	case '6': return 0xbe;
	case '7': return 0xe0;
	case '8': return 0xfe;
	case '9': return 0xf6;
	}	
}

void sure_7seg_write_str(char *data) {

uns8 count, digit;
char converted[5];

	count = 0;
	do {
		digit = data[count];
		converted[count] = sure_7seg_convert(digit);
		count++;
	   } while (count < 4);
	spi_write_sure(converted[3]);
	spi_write_sure(converted[2]);
	spi_write_sure(converted[1]);
	spi_write_sure(converted[0]);

	clear_pin(spi_clk_port, spi_clk_pin);	// set to low
	set_pin(spi_clk_port, spi_clk_pin);	// set to high
	   
}

