#ifndef __config_h
#define __config_h
#include "platform.h"

#define FIRMWARE_VERSION "Version 1.0 for board v6"

// - - - - - - - - - - - - - - - - - - - - 
// pic_serial defines
// - - - - - - - - - - - - - - - - - - - - 

#define SERIAL_TX_BUFFER_SIZE 20
#define SERIAL_RX_BUFFER_SIZE 4

// Use this define if you want fine-grained control of what happens in the serial port
//#define SERIAL_DEBUG_ON

// Use this define if you are debugging in the IDE simulator and don't want it to hang
// waiting for serial interrupts that will never come...
//#define SERIAL_IDE_DEBUG

// Use thie define if you want to drop a character if the TX buffer is full,
// rather than the default behaviour, which is to wait until the TX buffer has
// a spare spot.
//#define SERIAL_DISCARD_ON_TX_FULL_DURING_INT

// - - - - - - - - - - - - - - - - - - - - 
// pic_term defines
// - - - - - - - - - - - - - - - - - - - - 

#define TERM_BUFFER_SIZE	20
// Reset (go to bootloader) if magic character received
#define TERM_ALLOW_BOOSTBLOADER
// Echo typing so user can see what they're doing
#define TERM_ECHO_INPUT

// - - - - - - - - - - - - - - - - - - - - 

// Create term_entry_callback in your own code
// void term_entry_callback(uns8 *term_buffer);

// - - - - - - - - - - - - - - - - - - - - 
// ccld defines
// - - - - - - - - - - - - - - - - - - - - 

#define ccld_sin_port PORTA
#define ccld_sin_pin	 4

#define ccld_clk_port PORTC
#define ccld_clk_pin	 4

// Don't define bl port/pin, this is handled externally
//#define ccld_bl_port PORTC
//#define ccld_bl_pin	 4

#define ccld_lat_port PORTC
#define ccld_lat_pin	 6

// 0801 defines

#define dsp0801_d1_port PORTC
#define dsp0801_d1_pin  3

#define dsp0801_d2_port PORTC
#define dsp0801_d2_pin  2

#define dsp0801_d3_port PORTC
#define dsp0801_d3_pin  1

#define dsp0801_d4_port PORTA
#define dsp0801_d4_pin  5


// - - - - - - - - - - - - - - - - - - - - 
// spi_hw defines
// - - - - - - - - - - - - - - - - - - - - 

//#define SPI_HW_MASTER_MODE
// or
#define SPI_HW_SLAVE_MODE

// In slave mode, we can use ss:
//#define SPI_HW_USE_SS

// In master mode, we need to define clock
//#define SPI_HW_MASTER_CLOCK_TMR2_DIV_2
//#define SPI_HW_MASTER_CLOCK_FOSC_DIV_64
//#define SPI_HW_MASTER_CLOCK_FOSC_DIV_16
//#define SPI_HW_MASTER_CLOCK_FOSC_DIV_4

//#define SPI_HW_TRANSMIT_ON_ACT_TO_IDLE	
// or
#define SPI_HW_TRANSMIT_ON_IDLE_TO_ACT

//#define SPI_HW_CLK_IDLE_IS_HIGH
// or
#define SPI_HW_CLK_IDLE_IS_LOW

// - - - - - - - - - - - - - - - - - - - - 

#define DSP_0801_TOTAL_CHARS 8

// - - - - - - - - - - - - - - -
// General platform definitions
// - - - - - - - - - - - - - - -
#define PLATFORM_TYPE EA_DSP_0801
#define PLATFORM_CLOCK 32000000


#endif